package es.rickyepoderi.keycloaksample;

import android.os.AsyncTask;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

public abstract class BaseTask<Result> extends AsyncTask<String, Void, Result> {

    protected MainActivity activity;
    protected Callback callback;

    public BaseTask(MainActivity activity, Callback<Result> callback) {
        this.activity = activity;
        this.callback = callback;
    }

    public String readFullyAsString(InputStream inputStream, String encoding) throws IOException {
        return readFully(inputStream).toString(encoding);
    }

    public ByteArrayOutputStream readFully(InputStream inputStream) throws IOException {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        byte[] buffer = new byte[1024];
        int length = 0;
        while ((length = inputStream.read(buffer)) != -1) {
            baos.write(buffer, 0, length);
        }
        return baos;
    }

    @Override
    protected void onPostExecute(Result result) {
        callback.onPostExecute(activity, result);
    }
}
