package es.rickyepoderi.keycloaksample;

import android.util.Log;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;

public class UserInfoTask extends BaseTask<String> {

    private static final String TAG = "UserInfoTask";

    public UserInfoTask(MainActivity activity, Callback<String> callback) {
        super(activity, callback);
    }

    @Override
    protected String doInBackground(String... strings) {
        HttpURLConnection conn = null;
        try {
            String accessToken = strings[0];
            URL keycloak = activity.createUserInfoURL();
            conn = (HttpURLConnection) keycloak.openConnection();
            conn.setDoOutput(true);
            conn.setInstanceFollowRedirects(false);
            conn.setRequestMethod("GET");
            conn.setRequestProperty("Authorization", "Bearer " + accessToken);
            conn.setUseCaches(false);
            if (conn.getResponseCode() == 200) {
                return readFullyAsString(conn.getInputStream(), "UTF-8");
            } else {
                return conn.getResponseCode() + ": " + conn.getResponseMessage();
            }
        } catch (IOException e) {
            Log.d(TAG, "Error calling keycloak", e);
            return e.getMessage();
        } finally {
            if (conn != null) {
                conn.disconnect();
            }
        }
    }

    @Override
    protected void onPostExecute(String temp) {
        activity.setTextMain(temp);
    }
}
